var topnode;
var tree = new TreeView();
var list = new ListView();
var theMenu = new ExplorerMenu();
var fDrive = new FreeDrive();
GenerateMenuItems();
var nAffil = GetSubcookie("branding", "AFFILIATE_ID");
if (nAffil == "") {
	nAffil = "10406";
}

function ExplorerMenu() {
	this.html = null;
	this.dc = null;
	this.activenode = null;
	this.inprogressnode = null;
	this.cutnode = null;
	this.uploadfolder = null;
	this.Draw = DrawMenu;
	this.context = null;
	this.menuitems = new Array();
	this.Click = ClickMenuItem;
	this.Append = AppendMenuItem;
	this.GetItem = GetMenuItem;
}

function FreeDrive() {
	this.spacetotal = 20480;
	this.spaceused = 5400;
	this.input = null;
	this.Upload= UploadItem;
	this.Download = DowloadItem;
	this.New = NewNode;
	this.Cut = CutNode;
	this.Paste = PasteNode;
	this.Delete = DeleteNode;
	this.Rename = RenameNode;
	this.Share = ShareNode;
	this.Update = UpdateNode;
	this.Commit = CommitNode;
	this.UpdateShare = UpdateFolderShare;
	this.DeleteFreedrive = DeleteFreedrive;
}

function MenuItem(name, action, description, validtypes, invalidtypes, validstates,
invalidstates, disablestates, permissions) {
	this.name= name;
	this.action= action;
	this.description= description;
	this.validtypes= (validtypes == null) ? 0xFFFF : validtypes;
	this.invalidtypes= (invalidtypes == null) ? 0 : invalidtypes;
	this.validstates= (validstates == null) ? 0xFFFF : validstates;
	this.invalidstates= (invalidstates == null) ? 0 : invalidstates;
	this.mom= null;
	this.disablestates  = typeof(disablestates) == "number" ? disablestates : 0x0000;
	this.nPermissions= (permissions == null) ? 0 : permissions;
}

function GenerateMenuItems() {
	var desc;
	desc = "Upload some files into the currently open or selected folder";
	theMenu.Append(new MenuItem("Upload", "fDrive.Upload()", desc, typeFile + typeFolder + typeDrive, 0, null, stateRenaming + stateNew, null, permAdd + permOwner));
	desc = "Download the currently selected file on to your computer";
	theMenu.Append(new MenuItem("Download", "fDrive.Download(0)", desc, typeFile, 0, stateSelected, stateRenaming + stateNew, null, permView + permOwner));
	desc = "View the currently selected file";
	theMenu.Append(new MenuItem("View", "fDrive.Download(1)", desc, typeFile, 0, stateSelected, stateRenaming + stateNew, null, permView + permOwner));
	desc = "Create a new folder in the currently open or selected folder";
	theMenu.Append(new MenuItem("New Folder", "fDrive.New()", desc, typeFile + typeFolder + typeDrive, 0, null, stateRenaming + stateNew, null, permAdd + permOwner));
	desc = "Cut the currently selected item";
	theMenu.Append(new MenuItem("Cut", "fDrive.Cut()", desc, typeFolder + typeFile, 0, stateSelected, stateRenaming + stateNew + stateCut, null, permDelete + permOwner + permShortcut));
	desc = "Paste the clipboard to the currently open or selected folder";
	theMenu.Append(new MenuItem("Paste", "fDrive.Paste()", desc, typeFolder + typeDrive, 0, null, stateRenaming + stateNew, stateCut, permAdd + permOwner));
	desc = "Delete the currently selected item";
	theMenu.Append(new MenuItem("Delete", "fDrive.Delete()", desc, typeFolder + typeFile, 0, stateSelected, stateRenaming + stateNew, null, permDelete + permOwner + permShortcut));
	desc = "Rename the currently selected item";
	theMenu.Append(new MenuItem("Rename", "fDrive.Rename()", desc, typeFolder + typeFile, 0, stateSelected, stateRenaming + stateNew, null, permDelete + permOwner + permShortcut));
	desc = "Share the currently selected item to a group of FreeDrive users";
	theMenu.Append(new MenuItem("Share", "fDrive.Share()", desc, typeFolder + typeDrive, typeShortcut, null, stateRenaming + stateNew, null, permOwner));
}

function GetMenuItem(sMenuItemName) {
	var nCount = this.menuitems.length;
	for (var i = 0;
	i < nCount;
	i++) if (this.menuitems[i].name == sMenuItemName) return this.menuitems[i];
	return null;
}

function CommitNode(id) {
	var node = theMenu.inprogressnode;
	if (node.state & stateNew) {
		node.state &= ~stateNew;
		node.id = id;
	}
	if (node.state & stateRenaming) {
		node.name = this.input;
	}
	if (node.state & stateDeleting) {
		CutNodeOut(node);
		fDrive.spaceused = fDrive.spaceused - GetNodeSize(node);
	}
	if (theMenu.cutnode != null) {
		if ( ((node.state & stateDeleting) && (node == theMenu.cutnode)) || (theMenu.cutnode.state & statePasting) ) {
			if (theMenu.cutnode.state & statePasting) {
				CutNodeOut(theMenu.cutnode);
				tree.opennode.Append(theMenu.cutnode);
				node = theMenu.cutnode;
			}
			theMenu.cutnode.state &= ~(stateCut + statePasting);
			theMenu.cutnode = null;
			theMenu.GetItem("Paste").disablestates |= stateCut;
		}
	}
	if (node) list.UnSelect();
	tree.Draw();
}

function UpdateNode(input) {
	this.input = input.value;
	var node = theMenu.activenode;
	if (node.state & stateNew) {
		var id = (node.mom.id == null) ? "" : node.mom.id;
		if (!IsLegalName(this.input)) {
			window.alert("Cannot create " + input.value + ": Name cannot be empty, contain one of the following: \\/:*?\"<>|, or start with one of the following: #&");
		}
		else {
			node.name = GetUniqueName(input.value, node.mom, node.type);
			theMenu.Draw(null, "Processing insert, please wait...");
			theMenu.inprogressnode = theMenu.activenode;
			list.dc.location.href = "asp/UserReq.asp?Act=insert&pid=" + id + "&Name=" + node.name.replace(/\s/g, "%20");
			return;
		}
	}
	if (node.state & stateRenaming) {
		var NodeType = "Folder";
		if (node.type & typeFile) NodeType = "File";
		if (this.input != node.name) {
			if (!IsLegalName(this.input)) {
				window.alert("Cannot rename " + node.name + ": Name cannot be empty, contain one of the following: \\/:*?\"<>|, or start with one of the following: #&");
			}
			else if (this.input != GetUniqueName(this.input, node.mom, node.type)) {
				window.alert("Cannot rename " + node.name + ": an item already exists with this name.");
			}
			else {
				theMenu.Draw(null, "Renaming item, please wait...");
				theMenu.inprogressnode = theMenu.activenode;
				list.dc.location.href = "asp/UserReq.asp?Act=rename&id=" + node.id + "&NodeType=" + NodeType + "&NewName=" + input.value.replace(/\s/g, "%20") + "&MomID=" + node.mom.id;
				return;
			}
		}
		else list.UnSelect();
	}
}

function NewNode() {
	var nodeParent = tree.opennode;
	var node = new Node(GetUniqueName("New Folder", nodeParent, typeFolder),  nodeParent.level + 1, typeFolder, null, new Date(), null,  nodeParent.nPermissions & (~permShortcut), nodeParent.nOwnerID);
	nodeParent.Append(node);
	if ((nodeParent.state & stateOpen) == 0) {
		tree.Open(nodeParent, true);
		tree.Draw();
	}
	list.Select(node, true);
	node.state += stateNew + stateHasFocus;
	theMenu.Draw(node);
	list.Draw(node.mom);
}

function RenameNode() {
	theMenu.activenode.state += stateRenaming + stateHasFocus;
	theMenu.Draw(theMenu.activenode);
	list.Draw(theMenu.activenode.mom);
}

function DeleteNode() {
	if (!window.confirm("Do you really want to delete this item?")) return;
	var node = theMenu.activenode;
	var ids = "";
	var NodeType = "";
	node.state += stateDeleting;
	if (node.type & typeFolder){ NodeType = node.type & typeShortcut ? "Shortcut" : "Folder";
		ids = node.type & typeShortcut ? node.id : GetFolderIDs(node);
	}
	else if (node.type & typeFile){ NodeType = "File";
		ids = node.id;
	}
	theMenu.Draw(null, "Processing delete, please wait...");
	theMenu.inprogressnode = theMenu.activenode;
	list.dc.location.href = "asp/UserReq.asp?Act=delete&NodeType=" + NodeType + "&id=" + ids;
}

function GetFolderIDs(node) {
	var ids = node.id;
	if ((node.folders == null) || (node.type & typeShortcut)) return ids;
	var last = node.folders.length;
	for (var i = 0;
	i < last;
	i++) {
		ids += "," + GetFolderIDs(node.folders[i]);
	}
	return ids;
}

function CutNode() {
	if (theMenu.cutnode) theMenu.cutnode.state &= ~(stateCut);
	theMenu.cutnode = theMenu.activenode;
	theMenu.cutnode.state += stateCut;
	theMenu.cutnode.state ^= stateSelected;
	theMenu.GetItem("Paste").disablestates &= ~(stateCut);
	list.Draw(theMenu.cutnode.mom);
	theMenu.Draw(theMenu.activenode);
}

function PasteNode(node) {
	if (theMenu.cutnode == null) return;
	if (theMenu.cutnode.type & typeFolder) {
		if (theMenu.cutnode == tree.opennode) {
			window.alert("Cannot move " + theMenu.cutnode.name + ": The destination folder is the same as the source folder.");
			return;
		}
		if (theMenu.cutnode.IsRelated(tree.opennode)) {
			window.alert("Cannot move " + theMenu.cutnode.name + ": The destination folder is a subfolder of the source folder.");
			return;
		}
		if (theMenu.cutnode.name != GetUniqueName(theMenu.cutnode.name, tree.opennode, theMenu.cutnode.type)) {
			  window.alert("Cannot move " + theMenu.cutnode.name + ": The destination folder contains a folder with the same name.");
			  return;
		}
	}
	if (theMenu.cutnode.type & typeFile) {
		if (theMenu.cutnode.name != GetUniqueName(theMenu.cutnode.name, tree.opennode, theMenu.cutnode.type)) {
			window.alert("Cannot move " + theMenu.cutnode.name + ": The destination folder contains a file with the same name.");
			return;
		}
	}
	if ( (theMenu.cutnode.type & typeShortcut) && ((theMenu.activenode.type & typeShortcut) || !(theMenu.activenode.nPermissions & permOwner))) {
		window.alert("Cannot move '" + theMenu.cutnode.name + "' : shortcut cannot be moved to other freedrive account.");
		return;
	}
	if ((theMenu.activenode.nOwnerID != theMenu.cutnode.nOwnerID) && !(theMenu.cutnode.type & typeShortcut)) {
		window.alert("Cannot move '" + theMenu.cutnode.name + "' : moving between freedrive accounts is temporary disabled.");
		return;
	}
	var NodeType = (theMenu.cutnode.type & typeFolder) ? "Folder" : "File";
	theMenu.cutnode.state += statePasting;
	theMenu.inprogressnode = theMenu.activenode;
	theMenu.Draw(null, "Moving item, please wait...");
	list.dc.location.href = "asp/UserReq.asp?Act=move&NodeType=" + NodeType + "&id=" +  theMenu.cutnode.id + "&pid=" + theMenu.activenode.id;
}

function ShareNode() {
	var node = theMenu.activenode;
	theMenu.Draw(null, "Sharing information for: '" + node.name + "'");
	theMenu.inprogressnode = theMenu.activenode;
	list.dc.location.href = "asp/GetFolderShare.asp" + "?FolderID=" + node.id;
}

function UpdateFolderShare(folderID, esaSaveAction) {
	var node = theMenu.inprogressnode;
	if ( !(folderID) || node.id == folderID) {
		if (esaSaveAction == esaNew) node.type |= typeShared;
		else if (esaSaveAction == esaRemoved) node.type &= ~typeShared;
	}
	list.Draw((node == list.selectednode) ? node.mom : node);
	theMenu.Draw();
	tree.Draw();
}

function DowloadItem(bView, node) {
	if (node == null) node = theMenu.activenode;
	if ( node.nPermissions & permView) {
		var name = node.name.replace(/\s/g, "%20");
		var opts = "menubar=1,toolbar=0,statusbar=0,resizable=1,scrollbars=1,width=640,height=480";
		var uid = Math.ceil(Math.sqrt(node.id)) + node.id;
		SetCookie("id", node.id);
		if (bView) {
			var sURL = "HTML/GetFile.htm?act=view&uid=" + uid;
			window.open(sURL, uid, opts);
		}
		else {
			if (bIsIE4 != "0") {
				var sURL = "HTML/GetFile.htm?act=download&uid=" + uid;
				window.open(sURL, uid, opts);
			}
			else {
				var sURL = "1/GetFile.asp?act=download&uid=" + uid;
				list.dc.location.href = sURL;
			}
		}
	}
}

function UploadItem() {
	if (hWinStatus) {
		window.alert("You must allow the first upload to finish before beginning another.");
	}
	else {
		var node = tree.opennode;
		if (node == null) node = tree.topnode;
		SetCookie("FolderID", node.id);
		theMenu.uploadfolder = node;
		theMenu.Draw(null, "Upload files into: '" + node.name + "'");
		list.dc.location.href = "html/UploadFiles.htm";
	}
}

function ClickMenuItem(item) {
	if((this.menuitems[item].name == "Upload") || (this.menuitems[item].name == "Download") || (this.menuitems[item].name == "View") || (this.menuitems[item].name == "Share")) {
		setTimeout("frames['ad'].location.reload(true)");
	}
	eval(this.menuitems[item].action);
}

function AppendMenuItem(item) {
	this.menuitems[this.menuitems.length] = item;
	item.mom = this;
}

function DrawMenu(node, title) {
	var item, imgname;
	var last = this.menuitems.length;
	if (node) this.activenode = node;
	else node = this.activenode;
	this.html = "<HTML>\n<HEAD>\n" + g_sStyleSheet + "\n</HEAD>\n";
	if (title == null) {
		this.html += "<BODY class=\"content\" marginwidth=\"0\" marginheight=\"0\" topmargin=\"0\" bottommargin=\"0\" rightmargin=\"0\" leftmargin=\"0\">\n";
		this.html += "<TABLE WIDTH=\"100%\" height=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n";
		this.html += "<TR valign=middle ALIGN=CENTER>\n";
		for (var i = 0;
		i < last;
		i++) {
			item = this.menuitems[i];
			if ((item.nPermissions & node.nPermissions) && !item.disablestates && (node.type & item.validtypes) && !(node.type & item.invalidtypes) && (node.state & item.validstates) && !(node.state & item.invalidstates)) {
				imgname = "imgt" + i;
				this.html += "<TD><A title=\"" + item.description + "\"  class=\"content\" HREF=\"javascript:parent.theMenu.Click(" + i + ")\">\n";
				this.html += "<DIV class=\"marginitem\">" + item.name + "</DIV></A></TD>\n";
			}
			else {
				this.html += "<TD><DIV CLASS=\"marginitem\"><DIV class=\"disabled\">" + item.name + "</DIV></DIV></TD>\n";
			}
		}
	}
	else {
		this.html += "<BODY class=content marginwidth=10 marginheight=4 topmargin=10 bottommargin=0 rightmargin=30 leftmargin=10>\n";
		this.html += "<TABLE WIDTH=100% height=100% border=0 cellspacing=0 cellpadding=0>\n";
		this.html += "<TR valign=middle ALIGN=LEFT><TD class=contentheader><DIV class=contentitem><B>" + title + "</B></TD></TR>\n";
	}
	this.html += "</TABLE>\n";
	this.html += "</BODY>\n</HTML>\n";
	WriteToFrame(this);
}

function IsLegalName(name) {
	if ((name.search(/[\/\\:*?"<>|]/) > -1) || name == null || (name.search(/\S/g) == -1) || name.charAt(0) == "&" || name.charAt(0) == "#") return false;
	return true;
}

function GetUniqueName(name, node, type) {
	var postfix = "";
	var index = 0;
	var lastindex = 0;
	var collect = (type & typeFolder) ? node.folders : node.files;
	var last = (collect == null) ? 0 : collect.length;
	for (var i=0;i < last;
	i++) {
		if ((collect[i].id > 0) && (collect[i].name.toLowerCase().indexOf(name.toLowerCase()) == 0)) {
			if (collect[i].name.length == name.length) {
				index = 2;
			}
			else {
				postfix = collect[i].name.slice(name.length);
				if ((postfix.charAt(1) == "(") && (postfix.charAt(3) == ")")) {
					newindex = Number(Number(postfix.charAt(2)) + 1);
					if (newindex > index) index = newindex;
				}
			}
		}
	}
	if (index > 0) return name + " (" + index.toString() + ")";
	else return name;
}

function Redraw() {
	g_bFirstDraw = false;
	if (tree.opennode) {
		tree.Draw();
		theMenu.Draw();
		list.Draw(tree.opennode);
	}
	else tree.Open(tree.topnode);
}

function StartUp() {
	theMenu.dc = menubar;
	list.dc = frContent;
	tree.dc = sidemargin;
	tree.Open(topnode, true);
	topnode.state = stateExpanded;
	tree.topnode = topnode;
	CallFunc("tree.Draw()");
	theMenu.Draw(topnode);
}

function CallCommit(id) {
	var wait;
	if (id == null) id = "";
	if (bIsNetscape) {
		wait = 750;
	}
	else wait = 1;
	CallFunc("fDrive.Commit(" + id + ")", wait);
}

function WriteToFrame(display) {
	var doc = display.dc.document;
	doc.open("text/html", "replace");
	doc.write(display.html);
	doc.close();
}

function CommitDeleteFreedrive() {
	var wait;
	if (bIsNetscape) {
		wait = 750;
	}
	else wait = 1;
	CallFunc("fDrive.DeleteFreedrive()", wait);
}

function DeleteFreedrive() {
	SetCookie("session", "expired");
	GetPage("", "FDhome.htm?LoginText=Your%20Freedrive%20has%20been%20successfully%20deleted.");
}

function AppendChild(mom, name, level, type, id, modified, size, nPermissions, nOwnerID) {
	if ( !(nPermissions)) nPermissions = mom.nPermissions & (~permShortcut);
	if ( !(nOwnerID)) nOwnerID = mom.nOwnerID;
	mom.Append(new Node(name, level, type, id, modified, size, nPermissions, nOwnerID));
}